/* fsl.h 
 *
 */

#ifndef __FSL_H
#define __FSL_H

#include "fslstructs.h"
#include "otherstructs.h"
#include "defines.h"


class FSL 
{
public:
  FSL();
  FSL(int fifo);
  ~FSL();

 public:
  int setFifo(int fifo);
  int SetupHeader(ObserverInfo *obsinfo);
  int OpenFile(Date *d);
  int CloseFile();
  int Log(void);
  int ReSync(void);
  int ReadFSLData(int *SVs, unsigned int *time, unsigned int *svmarkers0, unsigned int *svmarkers1, fslsatstruc4 *fslstuff,  fslsatstruc4 *noise, int *noisepresent, int flag);
  int ReadFSLData(int *SVs, unsigned int *time, unsigned int *svmarkers, fslsatstruc3 *fslstuff,  fslsatstruc3 *noise, int *noisepresent, int flag);
  int ReadFSLData(int *SVs, unsigned int *time, unsigned int *svmarkers, fslsatstruc0 *fslstuff ,  fslsatstruc0 *noise, int  *noisepresent, int flag);
  int CheckAvailability(int prn,int verision, unsigned int *time, unsigned int *svmarkers);
  int FSL::CheckAvailability(int prn, int version, unsigned int *time, unsigned int *svmarkers0, unsigned int *svmarkers1);
int ReadHeader(fslhdrstruc4 *header);
  int ReadHeader(fslhdrstruc3 *header);
  int ReadHeader(fslhdrstruc0 *header);
  int ReadVersion(int &version);
  int WriteHeader(Date *d, Time *t, double *x, double *y, double *z);
  int StopLogging(void);
  int GenerateFilename(Date *d, char *filename, int i);
  int isActive() {return fsllogfile.Active;}
  int OpenFSLFile(char *filename);
  int GetFSLFileFID() {return FSLfile;}
  void printHeader(fslhdrstruc0 &hdr);
  void printHeader(fslhdrstruc3 &hdr);
  void printHeader(fslhdrstruc4 &hdr);
  char* GetFilename(void) {return fsllogfile.Filename;}
  Time GetLogTime(void) {return fsllogfile.time;}

protected:
  void CRCgen(unsigned int t, unsigned int s, unsigned char *crc);
  void CRCgen(unsigned int t, unsigned int s0, unsigned int s1,unsigned char *crc);
  void Checksum(fslsatstruc4 *rec);
  void Checksum(fslsatstruc3 *rec);
  void Checksum(fslsatstruc0 *rec);
  int CRCcheck(unsigned int t, unsigned int s, unsigned char crc);
  int CRCcheck(unsigned int t, unsigned int s0, unsigned int s1, unsigned char crc);

private:
  int FSLfile;
  int FSLfifo;
  int outfile;
  ObserverInfo obsinfo;
  FSLLogFile fsllogfile;

};

#endif


